"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from enum import Enum
from typing import Optional
from typing_extensions import NotRequired, TypedDict
from unified_python_sdk.types import BaseModel


class APICallType(str, Enum):
    LOGIN = "login"
    WEBHOOK = "webhook"
    INBOUND = "inbound"


class APICallTypedDict(TypedDict):
    integration_type: str
    method: str
    name: str
    path: str
    status: str
    type: APICallType
    connection_id: NotRequired[str]
    created_at: NotRequired[datetime]
    environment: NotRequired[str]
    error: NotRequired[str]
    external_xref: NotRequired[str]
    id: NotRequired[str]
    ip_address: NotRequired[str]
    is_billable: NotRequired[bool]
    size: NotRequired[float]
    webhook_id: NotRequired[str]
    workspace_id: NotRequired[str]


class APICall(BaseModel):
    integration_type: str

    method: str

    name: str

    path: str

    status: str

    type: APICallType

    connection_id: Optional[str] = None

    created_at: Optional[datetime] = None

    environment: Optional[str] = "Production"

    error: Optional[str] = None

    external_xref: Optional[str] = None

    id: Optional[str] = None

    ip_address: Optional[str] = None

    is_billable: Optional[bool] = None

    size: Optional[float] = None

    webhook_id: Optional[str] = None

    workspace_id: Optional[str] = None
