"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .enrichtelephone import EnrichTelephone, EnrichTelephoneTypedDict
from .property_enrichcompany_address import (
    PropertyEnrichCompanyAddress,
    PropertyEnrichCompanyAddressTypedDict,
)
from datetime import datetime
from typing import Any, Dict, List, Optional
from typing_extensions import NotRequired, TypedDict
from unified_python_sdk.types import BaseModel


class EnrichCompanyTypedDict(TypedDict):
    r"""A company object from an enrichment integration"""

    address: NotRequired[PropertyEnrichCompanyAddressTypedDict]
    r"""The address of the company"""
    alexa_rank: NotRequired[float]
    created_at: NotRequired[datetime]
    crunchbase_url: NotRequired[str]
    description: NotRequired[str]
    domain: NotRequired[str]
    employees: NotRequired[str]
    exchange: NotRequired[str]
    facebook_url: NotRequired[str]
    id: NotRequired[str]
    industry: NotRequired[str]
    instagram_url: NotRequired[str]
    linkedin_url: NotRequired[str]
    logo_url: NotRequired[str]
    naics_code: NotRequired[float]
    name: NotRequired[str]
    raw: NotRequired[Dict[str, Any]]
    r"""The raw data returned by the integration for this company"""
    revenue: NotRequired[str]
    sic_code: NotRequired[float]
    stock: NotRequired[str]
    telephones: NotRequired[List[EnrichTelephoneTypedDict]]
    r"""An array of telephones for this company"""
    twitter_handle: NotRequired[str]
    twitter_url: NotRequired[str]
    updated_at: NotRequired[datetime]
    year_founded: NotRequired[float]
    yelp_url: NotRequired[str]
    youtube_url: NotRequired[str]


class EnrichCompany(BaseModel):
    r"""A company object from an enrichment integration"""

    address: Optional[PropertyEnrichCompanyAddress] = None
    r"""The address of the company"""

    alexa_rank: Optional[float] = None

    created_at: Optional[datetime] = None

    crunchbase_url: Optional[str] = None

    description: Optional[str] = None

    domain: Optional[str] = None

    employees: Optional[str] = None

    exchange: Optional[str] = None

    facebook_url: Optional[str] = None

    id: Optional[str] = None

    industry: Optional[str] = None

    instagram_url: Optional[str] = None

    linkedin_url: Optional[str] = None

    logo_url: Optional[str] = None

    naics_code: Optional[float] = None

    name: Optional[str] = None

    raw: Optional[Dict[str, Any]] = None
    r"""The raw data returned by the integration for this company"""

    revenue: Optional[str] = None

    sic_code: Optional[float] = None

    stock: Optional[str] = None

    telephones: Optional[List[EnrichTelephone]] = None
    r"""An array of telephones for this company"""

    twitter_handle: Optional[str] = None

    twitter_url: Optional[str] = None

    updated_at: Optional[datetime] = None

    year_founded: Optional[float] = None

    yelp_url: Optional[str] = None

    youtube_url: Optional[str] = None
