"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from typing import Any, Dict, List, Optional
from typing_extensions import NotRequired, TypedDict
from unified_python_sdk.types import BaseModel


class PropertyConnectionAuthTypedDict(TypedDict):
    r"""An authentication object that represents a specific authorized user's connection to an integration."""

    access_token: NotRequired[str]
    api_url: NotRequired[str]
    app_id: NotRequired[str]
    authorize_url: NotRequired[str]
    client_id: NotRequired[str]
    client_secret: NotRequired[str]
    consumer_key: NotRequired[str]
    consumer_secret: NotRequired[str]
    dev_api_key: NotRequired[str]
    emails: NotRequired[List[str]]
    expires_in: NotRequired[float]
    expiry_date: NotRequired[datetime]
    key: NotRequired[str]
    meta: NotRequired[Dict[str, Any]]
    name: NotRequired[str]
    other_auth_info: NotRequired[List[str]]
    r"""When integration.auth_type = \"other\", this field contains the authentication credentials in the same order as token_names"""
    pem: NotRequired[str]
    refresh_token: NotRequired[str]
    refresh_token_expires_date: NotRequired[datetime]
    refresh_token_expires_in: NotRequired[float]
    state: NotRequired[str]
    token: NotRequired[str]
    token_url: NotRequired[str]
    user_id: NotRequired[str]


class PropertyConnectionAuth(BaseModel):
    r"""An authentication object that represents a specific authorized user's connection to an integration."""

    access_token: Optional[str] = None

    api_url: Optional[str] = None

    app_id: Optional[str] = None

    authorize_url: Optional[str] = None

    client_id: Optional[str] = None

    client_secret: Optional[str] = None

    consumer_key: Optional[str] = None

    consumer_secret: Optional[str] = None

    dev_api_key: Optional[str] = None

    emails: Optional[List[str]] = None

    expires_in: Optional[float] = None

    expiry_date: Optional[datetime] = None

    key: Optional[str] = None

    meta: Optional[Dict[str, Any]] = None

    name: Optional[str] = None

    other_auth_info: Optional[List[str]] = None
    r"""When integration.auth_type = \"other\", this field contains the authentication credentials in the same order as token_names"""

    pem: Optional[str] = None

    refresh_token: Optional[str] = None

    refresh_token_expires_date: Optional[datetime] = None

    refresh_token_expires_in: Optional[float] = None

    state: Optional[str] = None

    token: Optional[str] = None

    token_url: Optional[str] = None

    user_id: Optional[str] = None
